//Copyright Plasmatronics pty ltd 2023-2024 +61394869902
export default class Dom {
  constructor() {}

  table(id, domObjects){
    let classInstance = this;
    let table = document.createElement('div');
    table.setAttribute("id", id);
    domObjects.forEach(function(domObject) {
      table.append(
          classInstance.rowcell(domObject, "trow", "tcell"));
    });
    return table;
  }

  rowcell(domObject, rowClass = null, cellClass = null) {
    let row = document.createElement('div');
    row.classList.add(rowClass);
    let cell = document.createElement('div');
    cell.classList.add(cellClass);
    cell.append(domObject);
    row.append(cell);
    return row
  }

  button(name, id, clickEvent = null) {
    let button = document.createElement('button');
    button.setAttribute("id", id);
    button.addEventListener('click', clickEvent);
    button.textContent = name;
    return button;
  }

  input(id, changeEvent = null) {
    let input = document.createElement('input');
    input.setAttribute("id", id);
    input.addEventListener('input', changeEvent);
    return input;
  }

  radio(id, checked){
    let radio = document.createElement('div');
    let input = document.createElement('input');
    input.setAttribute("id", id);
    input.setAttribute("type", "radio");
    input.setAttribute("name", "radio");
    if(checked) input.setAttribute("checked", true);
    let label = this.text(id, 'label');
    label.setAttribute("for", id);
    radio.append(input);
    radio.append(label);
    return radio;
  }

  text(content, elementType) {
    let element = document.createElement(elementType);
    element.innerHTML = content;
    return element;
  }
}
