//Copyright Plasmatronics pty ltd 2023-2024 +61394869902
// Menu depends on prog, strt, stop, gmod, tmod, shunt/switch/mppt presence
export default class Menu {
  constructor() {
    this.menuItems = [
      {btn : "BATV", mode : 0, par : "ROOT", label : "BATV", reg : "batv"},
      {btn : "CHRG", mode : 0, par : "ROOT", label : "CHRG"},
      {btn : "CTOT", mode : 0, par : "CHRG", label : "CHRG", reg : "CTOT"},
      {btn : "CINT", mode : 0, par : "CHRG", label : "INT", reg : "cint" },
      {btn : "CEXT", mode : 0, par : "CHRG", label : "EXT", reg : "cext" },
      {btn : "LOAD", mode : 0, par : "ROOT", label : "LOAD"},
      {btn : "LTOT", mode : 0, par : "LOAD", label : "LOAD", reg : "LTOT"},
      {btn : "LINT", mode : 0, par : "LOAD", label : "INT", reg : "lint" },
      {btn : "LEXT", mode : 0, par : "LOAD", label : "EXT", reg : "lext" },
      {btn : "CHIN", mode : 0, par : "ROOT", label : "IN"},
      {btn : "CTIN", mode : 0, par : "CHIN", label : "IN", reg : "chin"  },
      {btn : "CIAH", mode : 0, par : "CHIN", label : "INT", reg : "ciah" },
      {btn : "IEXT", mode : 0, par : "CHIN", label : "EXT", reg : "IEXT" },
      {btn : "COUT", mode : 0, par : "ROOT", label : "OUT" },
      {btn : "CTUT", mode : 0, par : "COUT", label : "OUT", reg : "cout" },
      {btn : "LIAH", mode : 0, par : "COUT", label : "INT", reg : "liah" },
      {btn : "OEXT", mode : 0, par : "COUT", label : "EXT", reg : "OEXT" },
      {btn : "DATA", mode : 0, par : "ROOT", label : "DATA"},
      {btn : "VMAX", mode : 0, par : "DATA", label : "VMAX", reg : "vmax"},
      {btn : "VMIN", mode : 0, par : "DATA", label : "VMIN", reg : "vmin"},
      {btn : "FTIM", mode : 0, par : "DATA", label : "FTIM", reg : "ftim"},
      {btn : "SOC ", mode : 0, par : "DATA", label : "SOC", reg : "bsoc"},
      {btn : "TEMP", mode : 0, par : "DATA", label : "TEMP", reg : "temp"},
      {btn : "HIST", mode : 0, par : "DATA", label : "HIST"},
      {btn : "NEXT", mode : 0, par : "HIST", label : "NEXT", reg : "NEXT"},
      {btn : "PREV", mode : 0, par : "HIST", label : "PREV", reg : "PREV"},
      {btn : "SET ", mode : 0, par : "ROOT", label : "SET"},
      {btn : "TIME", mode : 0, par : "SET ", label : "TIME", reg : "time"},
      {btn : "VOLT", mode : 0, par : "SET ", label : "VOLT", reg : "volt"},
      {btn : "PROG", mode : 0, par : "SET ", label : "PROG", reg : "prog"},
      {btn : "BCAP", mode : 0, par : "SET ", label : "BCAP", reg : "bcap"},

      {btn : "DNET", mode : 8, par : "SET ", label : "DNET"},
      {btn : "STAT", mode : 8, par : "DNET", label : "STATUS", reg : "dstats"},

      {btn : "WIFI", mode : 8, par : "DNET", label : "WIFI"},
      {btn : "WIFM", mode : 8, par : "WIFI", label : "MODE"   , reg : "wifmod", dialog:"rbtn", lst:[ "Disabled", "Access Point", "Station" ]},
      {btn : "WIPA", mode : 8, par : "WIFI", label : "ADDRESS", reg : "wifipa", dialog:"ip4"},
      {btn : "WIPM", mode : 8, par : "WIFI", label : "MASK"   , reg : "wifipm", dialog:"ip4"},
      {btn : "WIPG", mode : 8, par : "WIFI", label : "GATEWAY", reg : "wifipg", dialog:"ip4"},
      {btn : "WDIP", mode : 8, par : "WIFI", label : "DHCP" , reg : "wifdip"},

      {btn : "WIID", mode : 8, par : "WIFI", label : "SSID", reg : "wifsid", dialog:"text"},
      {btn : "WIPW", mode : 8, par : "WIFI", label : "PASSWORD", reg : "wifpwd", dialog:"text"},

      {btn : "ETHE", mode : 8, par : "DNET", label : "ETHERNET"},
      {btn : "ETHM", mode : 8, par : "ETHE", label : "MODE", reg : "ethmod", dialog:"rbtn", lst:[ "Disabled", "Static IP Address", "DHCP Client" ]},
      {btn : "EIPS", mode : 8, par : "ETHE", label : "ADDRESS" , reg : "ethsip", dialog:"ip4"},
      {btn : "EIPM", mode : 8, par : "ETHE", label : "MASK"    , reg : "ethipm", dialog:"ip4"},
      {btn : "EIPG", mode : 8, par : "ETHE", label : "GATEWAY" , reg : "ethsgw", dialog:"ip4"},
      {btn : "DPLX", mode : 8, par : "ETHE", label : "DUPLEX"  , reg : "duplex", dialog:"rbtn", lst:[ "Half Duplex", "Full Duplex","Default"]},

      {btn : "MBUS", mode : 8, par : "DNET", label : "MODBUS"},
      {btn : "MBEN", mode : 8, par : "MBUS", label : "MODBUS" , reg : "mbwren",dialog:"rbtn", lst:[ "Disabled", "Enabled" ]},

      // {btn : "CANB", mode : 8, par : "DNET", label : "CANBUS"},
      // {btn : "CANM", mode : 8, par : "CANB", label : "CANBUS" , reg : "canmod"},
      {btn : "DFLT", mode : 8, par : "DNET", label : "RESET", reg : "dntver"},

      {btn : "UPDT", mode : 8, par : "DNET", label : "UPGRADE"  , reg : "update", dialog:"file"},
    ];
  }

  findItem(button){
	let menuItem = this.menuItems.find(i => i['btn'] == button);
    if(typeof menuItem != 'undefined'){
		return menuItem
	} else {
		return null
	}
  }
  	  
  findRegister(button){
    let menuItem = this.menuItems.find(i => i['btn'] == button);
    if(typeof menuItem != 'undefined'){
      if(typeof menuItem.reg != 'undefined'){
        return menuItem.reg;
      } else {
        return null;
      }
    }
  }

  update(button) {
    let menuList;
    let menuNode;
    let menuItem = this.menuItems.find(i => i['btn'] == button);
    if(typeof menuItem == 'undefined'){
      menuItem = this.menuItems[0];
    }

    let children = this.menuItems.filter(i => i['par'] == button);
    if(children.length != 0){
      menuList = children;
      menuNode = children[0];
    } else {
      // has no children, so return list of siblings
      let siblings = this.menuItems.filter(i => i['par'] == menuItem['par']);
      menuList = siblings;
      menuNode = menuItem;
    }

    // calculate back button
    let grandParent;
    let parent = this.menuItems.find(i => i['btn'] == menuNode['par']);
    if(typeof parent == 'undefined'){
      grandParent = this.menuItems[0];
    } else {
      grandParent = this.menuItems.find(i => i['btn'] == parent['par']);
      if(typeof grandParent == 'undefined'){
        grandParent = this.menuItems[0];
      }
    }

    if(menuNode['par'] != "ROOT"){
      menuList.push({label : "BACK", btn : grandParent['btn']});
    }

    return  { menuItems: menuList, activeItem: menuNode }
  }
}
