//Copyright Plasmatronics pty ltd 2023-2024 +61394869902
export default class Properties {
  static find(propertyName) {
    const properties = [
      {reg : "prog", label : "Program", units : "", format : "prog"},
      {reg : "volt", label : "System Voltage", units : "V", format : "volt"},
      {reg : "time", label : "Dingo Clock", units : "Hours", format : "time"},
      {reg : "temp", label : "Battery Temperature", units : "Celcius", format : "temp"},
      {reg : "batv", label : "Battery Voltage", units : "V", format : "deci"},
      {reg : "regv", label : "Regulation Voltage", units : "V", format : "deci"},
      {reg : "dequ", label : "Days Since Equalisation", units : "Days", format : "unit"},
      {reg : "dbst", label : "Days Since Boost", units : "Days", format : "unit"},
      {reg : "ftim", label : "Time Entered Float", units : "Hours", format : "time"},
      {reg : "bsoc", label : "Battery SOC", units : "Percent", format : "unit"},
      {reg : "vmax", label : "Battery Maximum Voltage", units : "V", format : "deci"},
      {reg : "vmin", label : "Battery Minimum Voltage", units : "V", format : "deci"},
      {reg : "ldst", label : "Load Status", units : "", format : "ldst"},
      {reg : "gnst", label : "Generator Status", units : "", format : "gnst"},
      {reg : "evst", label : "Event Status", units : "", format : "evst"},
      {reg : "cpst", label : "Charge Protection Status", u : "", format : "cpst"},
      {reg : "alst", label : "Alarm Status", units : "", format : "alst"},
      {reg : "lpst", label : "Load Protection Status", units : "", format : "lpst"},
      {reg : "regm", label : "Regulator Mode", units : "", format : "regm"},
      {reg : "vers", label : "Software Version", units : "", format : "unit"},
      {reg : "vcmp", label : "Temperature Compensation", units : "V", format : "deci"},

      {reg : "cint", label : "Internal Charge Current", units : "A", format : "deci"},
      {reg : "ciah", label : "Internal Accumulated Charge", units : "Ah", format : "unit"},
      {reg : "lint", label : "Internal Load Current", units : "A", format : "deci"},
      {reg : "liah", label : "Internal Accumulated Load", units : "Ah", format : "unit"},
      {reg : "cext", label : "External Charge Current", units : "A", format : "deci"},
      {reg : "chin", label : "Total Accumulated Charge", units : "Ah", format : "unit"},
      {reg : "lext", label : "External Load Current", units : "A", format : "deci"},
      {reg : "cout", label : "Total Accumulated Load", units : "Ah", format : "unit"},

      {reg : "xah1", label : "External Shunt 1 Accumulated", units : "Ah", format : "unit"},
      {reg : "xah2", label : "External Shunt 2 Accumulated", units : "Ah", format : "unit"},
      {reg : "xah3", label : "External Shunt 3 Accumulated", units : "Ah", format : "unit"},
      {reg : "xah4", label : "External Shunt 4 Accumulated", units : "Ah", format : "unit"},
      {reg : "xa01", label : "External Shunt 1 Current", units : "A", format : "deci"},
      {reg : "xa02", label : "External Shunt 2 Current", units : "A", format : "deci"},
      {reg : "xa03", label : "External Shunt 3 Current", units : "A", format : "deci"},
      {reg : "xa04", label : "External Shunt 4 Current", units : "A", format : "deci"},

      {reg : "gnon", label : "Generator Start Voltage", units : "V", format : "deci"},
      {reg : "goff", label : "Generator Stop Voltage", units : "V", format : "deci"},
      //eg {r : "gons"abel, l : "Generator Start SOC", u : "Percent", f : "unit"},
      //eg {r : "gofs"abel, l : "Generator Stop SOC", u : "Percent", f : "unit"},
      {reg : "gdel", label : "Generator Delay Time", units : "Minutes", format : "unit"},
      {reg : "gexd", label : "Generator Exercise Frequency", units : "Days", format : "unit"},
      {reg : "grun", label : "Generator Run Time", units : "Hours", format : "unit"},
      {reg : "loff", label : "Load Disconnect Voltage", units : "V", format : "deci"},
      {reg : "ldon", label : "Load Reconnect Voltage", units : "V", format : "deci"},
      {reg : "ldel", label : "Load Delay Time", units : "Minutes", format : "unit"},
      {reg : "alrm", label : "Alarm Activation Voltage", units : "V", format : "deci"},
      {reg : "bfrq", label : "Boost Frequency", units : "Days", format : "unit"},
      {reg : "atim", label : "Absorption Time", units : "Hours", format : "time"},
      {reg : "hyst", label : "Hysteresis Voltage", units : "V", format : "deci"},
      {reg : "bret", label : "Boost Return Voltage", units : "V", format : "deci"},
      {reg : "clim", label : "Current Limit", units : "A", format : "deci"},
      {reg : "bat2", label : "Battery 2 Regulation Voltage", units : "V", format: "deci"},
      {reg : "evsr", label : "Event Control 1", units : "", format : "unit"},

      {reg : "evsp", label : "Event Control 2", units : "", format : "unit"},
      {reg : "evtm", label : "Event Control 3", units : "", format : "unit"},
      {reg : "efrq", label : "Equalisation Frequency", units : "Days", format : "unit"},
      {reg : "etim", label : "Equalisation Time", units : "Hours", format : "unit"},
      {reg : "absv", label : "Absorption Voltage", units : "V", format : "deci"},
      {reg : "emax", label : "Equalise Voltage", units : "V", format : "deci"},
      {reg : "fltv", label : "Float Voltage", units : "V", format : "deci"},
      {reg : "bmax", label : "Boost Voltage", units : "V", format : "deci"},
      {reg : "gset", label : "Generator Output Control", units : "", format : "unit"},
      {reg : "lset", label : "Load Output Control", units : "", format : "unit"},
      {reg : "bset", label : "Battery Sense Control", units : "", format : "unit"},
      {reg : "pwmm", label : "PWM Mode Control", units : "", format : "unit"},
      {reg : "stop", label : "Event Stop Control", units : "", format : "unit"},
      {reg : "strt", label : "Event Start Control", units : "", format : "unit"},
      {reg : "tmod", label : "Event TMOD Control", units : "", format : "unit"},
      {reg : "emod", label : "Event EMOD Control", units : "", format : "unit"},
      {reg : "tcmp", label : "Temperature Compensation Mode", units : "", format : "unit"},
      {reg : "gmod", label : "Generator Mode Control", units : "", format : "unit"},
      {reg : "bcap", label : "Battery Capacity", units : "Ah", format : "unit"},

      {reg : "dvty", label : "Dingo Type", units : "", format : "unit"},
      {reg : "dvsn", label : "Dingo Serial Number", units : "", format : "unit"},
      {reg : "hstp", label : "History Offset", units : "Days", format : "unit"},

      {reg : "sc01", label : "External Switch 1 Control Byte", units : "", format : "unit"},
      {reg : "sc02", label : "External Switch 2 Control Byte", units : "", format : "unit"},
      {reg : "sah1", label : "External Switch 1 Accumulated", units : "Ah", format : "unit"},
      {reg : "sah2", label : "External Switch 2 Accumulated", units : "Ah", format : "unit"},
      {reg : "sa01", label : "External Switch 1 Current", units : "A", format : "deci"},
      {reg : "sd01", label : "External Switch 1 Duty", units : "Percent", format : "unit"},
      {reg : "st01", label : "External Switch 1 Temp", units : "Celcius", format : "temp"},
      {reg : "sa02", label : "External Switch 2 Current", units : "A", format : "deci"},
      {reg : "sd02", label : "External Switch 2 Duty", units : "Percent", format : "unit"},
      {reg : "st02", label : "External Switch 2 Temp", units : "Celcius", format : "temp"},

      {reg : "sc03", label : "External Switch 3 Control Byte", units : "", format : "unit"},
      {reg : "sc04", label : "External Switch 4 Control Byte", units : "", format : "unit"},
      {reg : "sah3", label : "External Switch 3 Accumulated", units : "Ah", format : "unit"},
      {reg : "sah4", label : "External Switch 4 Accumulated", units : "Ah", format : "unit"},
      {reg : "sa03", label : "External Switch 3 Current", units : "A", format : "deci"},
      {reg : "sd03", label : "External Switch 3 Duty", units : "Percent", format : "unit"},
      {reg : "st03", label : "External Switch 3 Temp", units : "Celcius", format : "temp"},
      {reg : "sa04", label : "External Switch 4 Current", units : "A", format : "deci"},
      {reg : "sd04", label : "External Switch 4 Duty", units : "Percent", format : "unit"},
      {reg : "st04", label : "External Switch 4 Temp", units : "Celcius", format : "temp"},

      {reg : "hvmx", label : "VMAX", units : "V", format : "deci"},
      {reg : "hvmn", label : "VMIN", units : "V", format : "deci"},
      {reg : "hflt", label : "FTIM", units : "", format : "time"},
      {reg : "hsoc", label : "SOC", units : "%", format : "unit"},
      {reg : "h-in", label : "IN", units : "Ah", format : "unit"},
      {reg : "hout", label : "OUT", units : "Ah", format : "unit"},

      //eg calculated abelvalues
      //eg ctot = cintabel + cext
      {reg : "CTOT", label : "Total Charge Current", units : "A", format : "deci"},
      //eg ltot = lintabel + lext
      {reg : "LTOT", label : "Total Load Current", units : "A", format : "deci"},
      //eg iext = c-inabel -ciah
      {reg : "IEXT", label : "External Accumulated Charge", units : "Ah", format : "unit"},
      //eg oext = coutabel - liah
      {reg : "OEXT", label : "External Accumulated Load", units : "A", format : "unit"},

      //eg dnet config values
      {reg : "dntver", label : "DNET Software Version", units : "", format : "str"},
      {reg : "dntbtm", label : "DNET Software Build Time", units : "", format : "str"},
      {reg : "espver", label : "ESPIDF Version", units : "", format : "str"},
      {reg : "wifmod", label : "WIFI Mode", units : "", format : "str", cfg : true},
      {reg : "wifipa", label : "IP4 Address", units : "", format : "str", cfg : true},
      {reg : "wifipg", label : "IP4 Gateway", units : "", format : "str", cfg : true},
      {reg : "wifipm", label : "IP4 Network Mask", units : "", format : "str", cfg : true},
      {reg : "wstmac", label : "WIFI Station MAC Address", units : "", format : "str"},
      {reg : "wifsid", label : "WIFI Network Name", units : "", format : "str", cfg : true},
      {reg : "wifpwd", label : "WIFI Network Password", units : "", format : "str", cfg : true},
      {reg : "wifdip", label : "WIFI DHCP IP4 Address", units : "", format : "str"},
      {reg : "wapmac", label : "WIFI Access Point MAC Address", units : "", format : "str"},
      {reg : "ethsip", label : "Ethernet Static IP4 Address", units : "", format : "str", cfg : true},
      {reg : "ethsgw", label : "Ethernet IP4 Gateway", units : "", format : "str", cfg : true},
      {reg : "ethipm", label : "Ethernet IP4 Network Mask", units : "", format : "str", cfg : true},
      {reg : "ethmod", label : "Ethernet Mode", units : "", format : "str", cfg : true},
      {reg : "ethmac", label : "Ethernet MAC Address", units : "", format : "str"},
      {reg : "canmod", label : "Canbus Mode", units : "", format : "str"},
      {reg : "mbwren", label : "Modbus Write Enable", units : "", format : "str", cfg : true},
      {reg : "cfgtmr", label : "Configuration Timer", units : "", format : "unit"},
      {reg : "rstdev", label : "Reset Device", units : "", format : "str"},
      {reg : "rstfct", label : "Reset Factory Defaults", units : "", format : "str"},
      {reg : "update", label : "Update Firmware", units : "", format : "hide", cfg : true},
      {reg : "rsemod", label : "Factory reset Mode", units : "", format : "str"},
      {reg : "rswmod", label : "Factory reset Mode", units : "", format : "str"},
      {reg : "rsteip", label : "Status", units : "", format : "str"},
      {reg : "rstwip", label : "Status", units : "", format : "str"},
      {reg : "dstats", label : "Status", units : "", format : "str"},
      {reg : "ethipa", label : "Current IP Address", units : "", format : "str"},
      {reg : "ethipg", label : "Current IP Gateway", units : "", format : "str"},
      {reg : "stemod", label : "Mode at startup", units : "", format : "str"},
      {reg : "stwmod", label : "Mode at startup", units : "", format : "str"},
      {reg : "duplex", label : "Duplex", units : "", format : "str",cfg:true},
    ];
    return properties.find(property => property['reg'] == propertyName);
  }
}
